from PIL import Image
import glob
import slideio
import sys
import os




def get_path(sti_til_mappe):
    while True:
        path = input(sti_til_mappe)
        if os.path.isdir(path):
            return path
        else:
            print("Error: Invalid file path.")
            continue




def get_downsampling_factor(sti_til_mappe):
    while True:
        try:
            value = int(input("Downsampling factor: "))
        except ValueError:
            print("Value error: Gi en verdi mellom 1 og 16")
            continue
        else:
            if value in range(1, 17):
                return value
            else:
                print("Value out of bounds: Gi en verdi mellom 1 og 16.")
                continue




def convert_svs(directory, downsampling_factor):
    for name in glob.glob(str(directory) + '/*.svs'):

        print(str("Opening slide " + str(name) + "..."), end="")
        try:
            slide = slideio.open_slide(name, 'SVS')
            print("[OK]".rjust(10))
        except:
            print("[ERROR]".rjust(10), sys.exc_info())
            continue

        print("Converting slide to PNG...", end="")
        try:
            scene = slide.get_scene(0)
            arr = scene.read_block(scene.rect,
                                   ((scene.rect[2] // downsampling_factor), (scene.rect[3] // downsampling_factor)))
            im = Image.fromarray(arr)
            print("[OK]".rjust(10))
        except:
            print("[ERROR]".rjust(10), sys.exc_info())
            continue

        try:
            name = name.rstrip(".svs") + ".png"
            print(str("Saving as " + str(name) + "..."), end="")
            im.save(name, 'PNG')
            print("[OK]".rjust(10))
            continue
        except:
            print("[ERROR]".rjust(10), sys.exc_info())
            continue






